PyPI Package:
  stage: test
  image: python:3.7
  services:
    - name: pypiserver/pypiserver:latest
      alias: pypiserver
      entrypoint: ["pypi-server", "-p", "8080", "-P", ".", "-a", ".", "packages"]
  except:
    - tags
    - master
  cache:
  script:
    - pipenv run tools/create_pypi_package
    - pipenv run twine upload -u "" -p "" --repository-url http://pypiserver:8080 $TMP_PKG_DIR/dist/*
    - rm -rf .venv
    - rm -rf src/drever
    - pip install virtualenv
    - virtualenv venv
    - source venv/bin/activate
    - pip install nose coverage junit2html imageio
    - imageio_download_bin freeimage
    - pip install --trusted-host pypiserver --index-url http://pypiserver:8080 drever
    - tools/run_tests
  artifacts:
    expire_in: 2 days
    when: always
    paths:
    - reports
    reports:
      junit: reports/tests/xunit.xml
      
python3.7-default: &python-default-test
  stage: test
  image: python:3.7
  except:
    - tags
  script:
    - pipenv run imageio_download_bin freeimage
    - pipenv run tools/run_tests
  coverage: '/TOTAL[0-9\s]+ (\d+)%/'
  artifacts:
    expire_in: 2 days
    when: always
    paths:
    - reports
    reports:
      junit: reports/tests/xunit.xml

python3.8: &python-none-default
  <<: *python-default-test
  image: python:3.8
  except:
    - tags
    - master
  script:
    - pipenv --python 3.8
    - pipenv install --dev
    - pipenv run imageio_download_bin freeimage
    - pipenv run python --version
    - pipenv run tools/run_tests
      
python3.9:
  <<: *python-none-default
  image: python:3.9
  allow_failure: true
  script:
    - pipenv --python 3.9
    - pipenv install --dev
    - pipenv run imageio_download_bin freeimage
    - pipenv run python --version
    - pipenv run tools/run_tests
  # No coverage for Python 3.5
  coverage:

# Python 3.8 is disabled until a stable 3.8 container is available!
#python3.8-rc:
#  <<: *python-none-default
#  allow_failure: true
#  image: python:3.8-rc
#  script:
#    - pipenv --python 3.8
#    - pipenv install --dev
#    - pipenv run imageio_download_bin freeimage
#    - pipenv run python --version
#    - pipenv run tools/run_tests
#  artifacts:
#    reports:
#      junit:
